#!/usr/bin/env node
;(function () { // wrapper in case we're in module_context mode
var log = require("../lib/utils/log");
log.waitForConfig();
log.info("ok", "it worked if it ends with");

var fs = require("fs")
  , path = require("path")
  , output = require("../lib/utils/output")
  , sys = require("../lib/utils/sys")
  , fhc = require("../fhc")
  , ini = require("../lib/utils/ini")
  , errorHandler = require("../lib/utils/error-handler")
  , configDefs = require("../lib/utils/config-defs")
  , shorthands = configDefs.shorthands
  , types = configDefs.types
  , nopt = require("nopt");
var util = require('util');

//log.verbose(process.argv, "cli");

var conf = nopt(types, shorthands);
fhc.argv = conf.argv.remain;
if (fhc.deref(fhc.argv[0])) fhc.command = fhc.argv.shift();
else conf.usage = true;


if (conf.version) {
  console.log(fhc.version);
  return;
} else log("fhc@"+fhc.version, "using");
log("node@"+process.version, "using");

// make sure that this version of node works with this version of fhc.
var semver = require("semver")
  , nodeVer = process.version
  , reqVer = fhc.nodeVersionRequired;

if (reqVer && !semver.satisfies(nodeVer, reqVer)) {
  return errorHandler(new Error("fhc doesn't work with node " + nodeVer + "\nRequired: node@" + reqVer), true);
}

process.on("uncaughtException", errorHandler);

if (conf.usage && fhc.command !== "help") {
  fhc.argv.unshift(fhc.command);
  fhc.command = "help";
}

// now actually fire up fhc and run the command.
// this is how to use fhc programmatically:
conf._exit = true;
fhc.load(conf, function (err) {  
  if (err) return errorHandler(err);
  fhc.commands[fhc.command](fhc.argv, function(err, data) {
    if (err) return errorHandler(err);

    // special output for apps logs. TODO still should be able to get json output for logs via by setting a flag.. 
    if ("apps" === fhc.command && fhc.argv[0] != undefined && fhc.argv[0] === 'logs') {
      console.log("\n====> stdout <====");
      console.log(data.logs.stdout);
      console.log("====> stderr <====");
      console.log(data.logs.stderr);      
      output.write('', errorHandler); 
    }else {
      if (data === undefined) {
        output.write("",errorHandler);     
      }        
      else {
        if (typeof data === 'string') return output.write(data, errorHandler);
          var json = require('jsontool');
          var argz = {
            lookup: null,
            extra: [],
            help: false,
            quiet: false,
            dropHeaders: false,
            outputSysInspect: false,
            outputJSON: false,
            experimental: false
          };
        
        if (conf.filter) {
          var script;
          if(conf.filter.substring(0,1) === '[') {
            script = "json.printData(json.processDatum(data" + conf.filter + ", argz), argz)";
          }else {
            script = "json.printData(json.processDatum(data." + conf.filter + ", argz), argz)"; 
          }
          eval(script);
        }else{
         json.printData(json.processDatum(data, argz), argz);         
        }
        errorHandler();
      }        
    }
  });
})
})()
