
var log = require("./utils/log")
, fhc = require("../fhc")
, util = require('util')
, fhreq = require("./utils/request");

exports.doApiCall = function(host, uri, payload, errorMsg, cb) {
  fhreq.POST(host, uri, payload, function (er, remoteData, raw, respose){

    if (er){
      log.error(errorMsg + er);
      return cb(er);
    }

    if(remoteData.msg != undefined && remoteData.address != undefined){
      if (remoteData.address["login-status"] == 'none'){
        return cb("Error, check your login details.. \n" + remoteData.msg);
      }
    }       

    if (remoteData.status != undefined && remoteData.status != 'ok'){
      return cb(remoteData.message, remoteData);
    }
    return cb(null, remoteData);
  }); 
};

exports.waitForJob = function(cacheKey, start, cb) {
  setTimeout(function() {
    log.verbose("polling for '" + cacheKey + "' to complete", "Polling");
    var cc = new Object();
    cc.cacheKey = cacheKey;
    cc.start = start;
    var params = [cc];

    fhreq.GET(fhreq.getFeedHenryUrl(), 'box/srv/1.1/dat/log/read?cacheKeys=' +
            encodeURIComponent(JSON.stringify(params)), function (err, remoteData, raw, respose){
      if (err) return cb(err);
      if (remoteData[0].status != undefined && remoteData[0].status == 'pending') {
        log.silly(remoteData[0].log, "waitforjob");
        return exports.waitForJob(cacheKey, start++, cb);
      }else {
        return cb(null, remoteData);
      }
    });
  }, 500);
};
