
module.exports = props;
props.list = list;
props.read = set;

props.usage = "\nfhc props <app id>"
            + "\nfhc props set <app id> <key> <value>";
             
var log = require("./utils/log")
  , fhc = require("../fhc")
  , fhreq = require("./utils/request");

function props (args, cb) {
  if (args.length == 1) {    
    var appId = args[0];
    if (appId == "domain") return domainProps(cb);
    else return list(appId, cb);
  }    
  var action = args.shift();
  if (action == 'set') {
    if (args.length != 3) return usage(cb);
    set(args[0], args[1], args[2], cb);
  } else return usage(cb);
};

// TODO - refactor to use the generic api handler call in common
function list (appId, cb) {
  fhreq.POST(fhreq.getFeedHenryUrl(), "box/srv/1.1/ide/" + fhc.domain + "/app/list", function (er, remoteData, raw, response) {
    if (er) {
      log.error("Error listing props: " + er);
      return cb(er);
    }else {      
      if (remoteData.status != 'ok') {
        log.verbose(remoteData, "list");
        return cb(remoteData.message, remoteData);
      }

      var apps = remoteData.list;
      var cfg = new Object();
      
      for (var i=0; i<apps.length;i++) {
        if (apps[i].id == appId) {
          cfg = apps[i].config;
          break;
        }        
      }
      
      return cb(null, cfg);
    }
  });
};

function set (appId, k, v, cb) {  
  fhreq.POST(fhreq.getFeedHenryUrl(), "box/srv/1.1/ide/" + fhc.domain + "/app/setconfig", {guid: appId, key: k, value: v},  function (er, remoteData, raw, response) {
    if (er) {
      log.error("Error reading app: " + er);
      cb(er);
    }else {
      if (remoteData.status != 'ok') {          
        return cb(remoteData.messsage, remoteData);
      }  
      return cb(null, remoteData);   
    }
  });  
};

function domainProps (cb) {
  fhreq.GET(fhreq.getFeedHenryUrl(), "box/srv/1.1/sys/admin/domain/props?d=" + fhc.domain, function (er, remoteData, raw, response) {
    if (er) {
      log.error("Error listing domain props: " + er);
      return cb(er);
    }else {      
      return cb(null, remoteData);
    }
  });
};

function usage(cb) {
  cb("Usage:\n" + props.usage);
};
